/* primes.c
 * Created 2017-10-31
 * Copyright © 2017 by Mark Damon Hughes. All Rights Reserved.
 */

#include <stdlib.h>
#include <stdio.h>

typedef char BOOL;
const BOOL YES = 1;
const BOOL NO = 0;

long parseArgs(int argc, char **argv) {
	if (argc != 2) {
		printf("Usage: primes COUNT\n");
		exit(1);
	}
	return atol(argv[1]);
}

void clearPrimes(BOOL *p, long n) {
	p[0] = NO;
	p[1] = NO;
	for (long i = 2; i < n; ++i) {
		p[i] = YES;
	}
}

void sievePrimes(BOOL *p, long n) {
	for (long i = 2; i < n; ++i) {
		for (long j = i*i; j < n; j += i) {
			p[j] = NO;
		}
	}
}

void printPrimes(BOOL *p, long n) {
	for (long i = 1; i < n; ++i) {
		if (p[i]) {
			printf("%ld ", i);
		}
	}
	puts("");
}

int main(int argc, char **argv) {
	long n = parseArgs(argc, argv);
	BOOL p[n];
	clearPrimes(p, n);
	sievePrimes(p, n);
	printPrimes(p, n);
	return 0;
}
