#!/usr/bin/env racket -t-
;; Created 2019-04-23
;; Copyright © 2019 by Mark Damon Hughes. All Rights Reserved.

#lang racket

(define (clearPrimes p n)
	(vector-set! p 0 #f)
	(vector-set! p 1 #f)
)

(define (sievePrimes p n)
	{do [(i 2 (add1 i))] [(>= i n)]
		{do [(j (* i i) (+ j i))] [(>= j n)]
			(vector-set! p j #f)
		}
	}
)

(define (printPrimes p n)
	{do [(i 1 (add1 i))] [(>= i n)]
		(when (vector-ref p i) (printf "~A " i))
	}
	(newline)
)

(define (primes n)
	{let [(p (make-vector n #t))]
		(clearPrimes p n)
		(sievePrimes p n)
		(printPrimes p n)
	}
)

(define (main argv)
	(cond
		[(positive? (length argv))  (primes (string->number (car argv)) )]
		[else (printf "Usage: primes COUNT\n")]
	)
)

(main (vector->list (current-command-line-arguments)))
